/*************************************************************************
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 * Copyright 2008 by Nakata, Maho
 *
 * MPACK - multiple precision arithmetic library
 *
 * This file is part of MPACK.
 *
 * MPACK is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * only, as published by the Free Software Foundation.
 *
 * MPACK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3 for more details
 * (a copy is included in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU Lesser General Public License
 * version 3 along with MPACK.  If not, see
 * <http://www.gnu.org/licenses/lgpl.html>
 * for a copy of the LGPLv3 License.
 *
 ************************************************************************/

#include <mblas.h>

void
Rswap(int n, mpf_class * dx, int incx, mpf_class * dy, int incy)
{
    int ix, iy;
    mpf_class temp;

    if (n <= 0)
	return;
    ix = 0;
    iy = 0;

    if (incx < 0)
	ix = (-n + 1) * incx;
    if (incy < 0)
	iy = (-n + 1) * incy;
    for (int i = 0; i < n; i++) {
	mpf_swap(dx[ix].get_mpf_t(), dy[iy].get_mpf_t());
	ix = ix + incx;
	iy = iy + incy;
    }
    return;
}
