#include <stdio.h>
#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <complex>
#include <gmpxx.h>

#include <mblas.h>
#include <mblas.debug.h>
#define MAX_ITER 10

void
mpc_imag_test1()
{
    printf("Real <= Complex.im test \n");
    mpc_class Ctemp1;
    mpf_class Ftemp1;
    mpf_class Ftemp2;

    int flag = 0;

    for (int i = 0; i < MAX_ITER; i++) {
	Ctemp1 = mpc_randomnumber();
	Ftemp1 = imag(Ctemp1);	//this is what we want to test

/*
	printf("F1 =");
	gmp_printf(GMP_P_FORMAT, Ftemp1.get_mpf_t());
	printf("\n");
	printf("C1 =");
	gmp_printf(GMP_P_FORMAT, Ctemp1.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp1.im.get_mpf_t());
	printf("i\n");
	printf("\n");
*/
	Ftemp2 = Ctemp1.im - Ftemp1;
	mpf_class diff = abs(Ftemp2);

/*
	printf("DIFF ");
	gmp_printf(GMP_P_FORMAT, diff.get_mpf_t());
	printf("\n");
*/

	if (abs(diff) > EPSILON) {
	    flag = 1;
	}
    }
    if (flag) {
	printf("Real <= Complex.im test failed\n");
	exit(-1);
    } else {
	printf("Real <= Complex.im test passed\n");
    }
}


void
mpc_real_test1()
{
    printf("Real <= Complex.real test \n");
    mpc_class Ctemp1;
    mpf_class Ftemp1;
    mpf_class Ftemp2;

    int flag = 0;

    for (int i = 0; i < MAX_ITER; i++) {
	Ctemp1 = mpc_randomnumber();

	Ftemp1 = real(Ctemp1);	//this is what we want to test
/*
	printf("F1 =");
	gmp_printf(GMP_P_FORMAT, Ftemp1.get_mpf_t());
	printf("\n");
	printf("C1 =");
	gmp_printf(GMP_P_FORMAT, Ctemp1.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp1.im.get_mpf_t());
	printf("i\n");
	printf("\n");
*/

	Ftemp2 = Ctemp1.re - Ftemp1;
	mpf_class diff = abs(Ftemp2);

/*
	printf("DIFF ");
	gmp_printf(GMP_P_FORMAT, diff.get_mpf_t());
	printf("\n");
*/
	if (abs(diff) > EPSILON) {
	    flag = 1;
	}
    }
    if (flag) {
	printf("Real <= Complex.real test failed\n");
	exit(-1);
    } else {
	printf("Real <= Complex.real test passed\n");
    }
}

void
mpc_subst_test1()
{
    printf("Complex <= Real test \n");
    mpc_class Ctemp1;
    mpc_class Ctemp2;
    mpf_class Ftemp;

    int flag = 0;

    for (int i = 0; i < MAX_ITER; i++) {
	Ftemp = mpf_randomnumber();

	Ctemp1 = Ftemp;		//this is what we want to test
/*
	printf("F =");
	gmp_printf(GMP_P_FORMAT, Ftemp.get_mpf_t());
	printf("\n");
	printf("C1 =");
	gmp_printf(GMP_P_FORMAT, Ctemp1.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp1.im.get_mpf_t());
	printf("i\n");
	printf("\n");
*/

	Ctemp2 = Ctemp1 - Ftemp;
	mpf_class diff = abs(Ctemp2);

/*
	printf("DIFF ");
	gmp_printf(GMP_P_FORMAT, diff.get_mpf_t());
	printf("\n");
	if (abs(diff) > EPSILON) {
	    flag = 1;
	}
*/

    }
    if (flag) {
	printf("Complex <= Real subst test failed\n");
	exit(-1);
    } else {
	printf("Complex <= Real subst test passed\n");
    }
}

void
mpc_add_test1()
{
    printf("Complex + Complex test \n");
    mpc_class Ctemp1;
    mpc_class Ctemp2;
    mpc_class Ctemp3;
    mpf_class Ftemp;
    mpf_class diff;

    complex < double >ctemp1;
    complex < double >ctemp2;
    complex < double >ctemp3;

    int flag = 0;

    for (int i = 0; i < MAX_ITER; i++) {
	Ctemp1 = mpc_randomnumber();
	Ctemp2 = mpc_randomnumber();

	ctemp1.real() = Ctemp1.re.get_d();
	ctemp1.imag() = Ctemp1.im.get_d();
	ctemp2.real() = Ctemp2.re.get_d();
	ctemp2.imag() = Ctemp2.im.get_d();

/*
	printf("C1 =");
	gmp_printf(GMP_P_FORMAT, Ctemp1.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp1.im.get_mpf_t());
	printf("i\n");
	printf("C2 =");
	gmp_printf(GMP_P_FORMAT, Ctemp2.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp2.im.get_mpf_t());
	printf("i\n");
*/

	Ctemp3 = Ctemp1 + Ctemp2;

/*
	printf("C3 =");
	gmp_printf(GMP_P_FORMAT, Ctemp3.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp3.im.get_mpf_t());
	printf("i\n");
	printf("\n");

	printf("c1 =");
	printf(P_FORMAT, ctemp1.real());
	printf("+");
	printf(P_FORMAT, ctemp1.imag());
	printf("i\n");

	printf("c2 =");
	printf(P_FORMAT, ctemp2.real());
	printf("+");
	printf(P_FORMAT, ctemp2.imag());
	printf("i\n");
*/

	ctemp3 = ctemp1 + ctemp2;
/*
	printf("c3 =");
	printf(P_FORMAT, ctemp3.real());
	printf("+");
	printf(P_FORMAT, ctemp3.imag());
	printf("i\n");
	printf("\n");
*/
	diff = abs(Ctemp3 - ctemp3);
/*
	printf("DIFF ");
	gmp_printf(GMP_P_FORMAT, diff.get_mpf_t());
	printf("\n");
*/
	if (abs(diff) > EPSILON) {
	    flag = 1;
	}
    }
    if (flag) {
	printf("Complex + Complex ADD test failed\n");
	exit(-1);
    } else {
	printf("Complex + Complex ADD test passed\n");
    }
}

void
mpc_add_test2()
{
    printf("Complex + Real test \n");
    mpc_class Ctemp1;
    mpf_class Ftemp2;
    mpc_class Ctemp3;

    mpf_class Ftemp;
    mpf_class diff;

    complex < double >ctemp1;
    double ftemp2;
    complex < double >ctemp3;

    int flag = 0;

    for (int i = 0; i < MAX_ITER; i++) {
	Ctemp1 = mpc_randomnumber();
	Ftemp2 = mpf_randomnumber();

	ctemp1.real() = Ctemp1.re.get_d();
	ctemp1.imag() = Ctemp1.im.get_d();
	ftemp2 = Ftemp2.get_d();
/*
	printf("C1 =");
	gmp_printf(GMP_P_FORMAT, Ctemp1.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp1.im.get_mpf_t());
	printf("i\n");

	printf("F2 =");
	gmp_printf(GMP_P_FORMAT, Ftemp2.get_mpf_t());
	printf("\n");
*/
	Ctemp3 = Ctemp1 + Ftemp2;
/*
	printf("C3 =");
	gmp_printf(GMP_P_FORMAT, Ctemp3.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp3.im.get_mpf_t());
	printf("i\n");
	printf("\n");

	printf("c1 =");
	printf(P_FORMAT, ctemp1.real());
	printf("+");
	printf(P_FORMAT, ctemp1.imag());
	printf("i\n");

	printf("f2 =");
	printf(P_FORMAT, ftemp2);
	printf("\n");
*/
	ctemp3 = ctemp1 + ftemp2;
/*
	printf("c3 =");
	printf(P_FORMAT, ctemp3.real());
	printf("+");
	printf(P_FORMAT, ctemp3.imag());
	printf("i\n");
	printf("\n");
*/
	diff = abs(Ctemp3 - ctemp3);
/*
	printf("DIFF ");
	gmp_printf(GMP_P_FORMAT, diff.get_mpf_t());
	printf("\n");
*/
	if (abs(diff) > EPSILON) {
	    flag = 1;
	}
    }
    if (flag) {
	printf("Complex + Real ADD test failed\n");
	exit(-1);
    } else {
	printf("Complex + Real ADD test passed\n");
    }
}


void
mpc_add_test3()
{
    printf("Real + Complex test \n");
    mpc_class Ctemp1;
    mpf_class Ftemp2;
    mpc_class Ctemp3;

    mpf_class Ftemp;
    mpf_class diff;

    complex < double >ctemp1;
    double ftemp2;
    complex < double >ctemp3;

    int flag = 0;

    for (int i = 0; i < MAX_ITER; i++) {
	Ctemp1 = mpc_randomnumber();
	Ftemp2 = mpf_randomnumber();

	ctemp1.real() = Ctemp1.re.get_d();
	ctemp1.imag() = Ctemp1.im.get_d();
	ftemp2 = Ftemp2.get_d();
/*
	printf("C1 =");
	gmp_printf(GMP_P_FORMAT, Ctemp1.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp1.im.get_mpf_t());
	printf("i\n");
	printf("F2 =");
	gmp_printf(GMP_P_FORMAT, Ftemp2.get_mpf_t());
	printf("\n");
*/
	Ctemp3 = Ftemp2 + Ctemp1;

/*
	printf("C3 =");
	gmp_printf(GMP_P_FORMAT, Ctemp3.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp3.im.get_mpf_t());
	printf("i\n");
	printf("\n");

	printf("c1 =");
	printf(P_FORMAT, ctemp1.real());
	printf("+");
	printf(P_FORMAT, ctemp1.imag());
	printf("i\n");

	printf("f2 =");
	printf(P_FORMAT, ftemp2);
	printf("\n");
*/

	ctemp3 = ftemp2 + ctemp1;
/*
	printf("c3 =");
	printf(P_FORMAT, ctemp3.real());
	printf("+");
	printf(P_FORMAT, ctemp3.imag());
	printf("i\n");
	printf("\n");
*/
	diff = abs(Ctemp3 - ctemp3);
/*
     	printf("DIFF ");
	gmp_printf(GMP_P_FORMAT, diff.get_mpf_t());
	printf("\n");
*/
	if (abs(diff) > EPSILON) {
	    flag = 1;
	}
    }
    if (flag) {
	printf("Real + Complex test failed\n");
	exit(-1);
    } else {
	printf("Real + Complex test passed\n");
    }
}

void
mpc_abs_test()
{
    printf("Complex abs test \n");
    mpc_class Ctemp1;
    mpf_class Ftemp1;
    mpf_class diff;
    double ftemp1;
    int flag = 0;

    for (int i = 0; i < MAX_ITER; i++) {
	Ctemp1 = mpc_randomnumber();
	complex < double >ctemp1(Ctemp1.re.get_d(), Ctemp1.im.get_d());

	Ftemp1 = abs(Ctemp1);
	ftemp1 = abs(ctemp1);
	diff = abs(Ftemp1 - ftemp1);
/*
	printf("GMP Complex number \n");
	gmp_printf(GMP_P_FORMAT, Ctemp1.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp1.im.get_mpf_t());
	printf("i\n");
	printf("C++ Complex number \n");
	printf(P_FORMAT, ctemp1.real());
	printf("+");
	printf(P_FORMAT, ctemp1.imag());
	printf("i\n");
	printf("\n");
	printf("ABS of GMP complex number = ");
	gmp_printf(GMP_P_FORMAT, Ftemp1.get_mpf_t());
	printf("\n");
	printf("ABS of C++ complex number = ");
	printf(P_FORMAT, ftemp1);
	printf("\n");
	printf("DIFF ");
	gmp_printf(GMP_P_FORMAT, diff.get_mpf_t());
	printf("\n");
*/
	if (abs(Ftemp1 - ftemp1) > EPSILON) {
	    flag = 1;
	}
    }
    if (flag) {
	printf("Complex ABS test failed\n");
	exit(-1);
    } else {
	printf("Complex ABS test passed\n");
    }

}

void
mpc_mul_test1()
{
    printf("Complex * Complex test \n");
    mpc_class Ctemp1;
    mpc_class Ctemp2;
    mpc_class Ctemp3;
    mpf_class Ftemp;
    mpf_class diff;

    complex < double >ctemp1;
    complex < double >ctemp2;
    complex < double >ctemp3;

    int flag = 0;

    for (int i = 0; i < MAX_ITER; i++) {
	Ctemp1 = mpc_randomnumber();
	Ctemp2 = mpc_randomnumber();

	ctemp1.real() = Ctemp1.re.get_d();
	ctemp1.imag() = Ctemp1.im.get_d();
	ctemp2.real() = Ctemp2.re.get_d();
	ctemp2.imag() = Ctemp2.im.get_d();
/*
	printf("C1 =");
	gmp_printf(GMP_P_FORMAT, Ctemp1.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp1.im.get_mpf_t());
	printf("i\n");
	printf("C2 =");
	gmp_printf(GMP_P_FORMAT, Ctemp2.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp2.im.get_mpf_t());
	printf("i\n");
*/
	Ctemp3 = Ctemp1 * Ctemp2;

/*
	printf("C3 =");
	gmp_printf(GMP_P_FORMAT, Ctemp3.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp3.im.get_mpf_t());
	printf("i\n");
	printf("\n");
	printf("c1 =");
	printf(P_FORMAT, ctemp1.real());
	printf("+");
	printf(P_FORMAT, ctemp1.imag());
	printf("i\n");
	printf("c2 =");
	printf(P_FORMAT, ctemp2.real());
	printf("+");
	printf(P_FORMAT, ctemp2.imag());
	printf("i\n");
*/

	ctemp3 = ctemp1 * ctemp2;
/*
	printf("c3 =");
	printf(P_FORMAT, ctemp3.real());
	printf("+");
	printf(P_FORMAT, ctemp3.imag());
	printf("i\n");
	printf("\n");
	diff = abs(Ctemp3 - ctemp3);
	printf("DIFF ");
	gmp_printf(GMP_P_FORMAT, diff.get_mpf_t());
	printf("\n");
*/
	if (abs(diff) > EPSILON) {
	    flag = 1;
	}
    }
    if (flag) {
	printf("Complex * Complex test failed\n");
	exit(-1);
    } else {
	printf("Complex * Complex test passed\n");
    }
}

void
mpc_mul_test2()
{
    printf("Complex * Real test \n");
    mpc_class Ctemp1;
    mpf_class Ftemp2;
    mpc_class Ctemp3;
    mpf_class Ftemp;
    mpf_class diff;

    complex < double >ctemp1;
    double ftemp2;
    complex < double >ctemp3;

    int flag = 0;

    for (int i = 0; i < MAX_ITER; i++) {
	Ctemp1 = mpc_randomnumber();
	Ftemp2 = mpf_randomnumber();

	ctemp1.real() = Ctemp1.re.get_d();
	ctemp1.imag() = Ctemp1.im.get_d();
	ftemp2 = Ftemp2.get_d();

/*
	printf("C1 =");
	gmp_printf(GMP_P_FORMAT, Ctemp1.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp1.im.get_mpf_t());
	printf("i\n");

	printf("F2 =");
	gmp_printf(GMP_P_FORMAT, Ftemp2.get_mpf_t());
	printf("\n");
*/
	Ctemp3 = Ctemp1 * Ftemp2;
/*
	printf("C3 =");
	gmp_printf(GMP_P_FORMAT, Ctemp3.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp3.im.get_mpf_t());
	printf("i\n");
	printf("\n");

	printf("c1 =");
	printf(P_FORMAT, ctemp1.real());
	printf("+");
	printf(P_FORMAT, ctemp1.imag());
	printf("i\n");

	printf("f2 =");
	printf(P_FORMAT, ftemp2);
	printf("\n");
*/
	ctemp3 = ctemp1 * ftemp2;

/*
	printf("c3 =");
	printf(P_FORMAT, ctemp3.real());
	printf("+");
	printf(P_FORMAT, ctemp3.imag());
	printf("i\n");
	printf("\n");
*/
	diff = abs(Ctemp3 - ctemp3);
/*
	printf("DIFF ");
	gmp_printf(GMP_P_FORMAT, diff.get_mpf_t());
	printf("\n");
*/
	if (abs(diff) > EPSILON) {
	    flag = 1;
	}
    }
    if (flag) {
	printf("Complex * Real test failed\n");
	exit(-1);
    } else {
	printf("Complex * Real test passed\n");
    }
}

void
mpc_mul_test3()
{
    printf("Real * Complex test \n");
    mpc_class Ctemp1;
    mpf_class Ftemp2;
    mpc_class Ctemp3;
    mpf_class Ftemp;
    mpf_class diff;

    complex < double >ctemp1;
    double ftemp2;
    complex < double >ctemp3;

    int flag = 0;

    for (int i = 0; i < MAX_ITER; i++) {
	Ctemp1 = mpc_randomnumber();
	Ftemp2 = mpf_randomnumber();

	ctemp1.real() = Ctemp1.re.get_d();
	ctemp1.imag() = Ctemp1.im.get_d();
	ftemp2 = Ftemp2.get_d();
/*
	printf("C1 =");
	gmp_printf(GMP_P_FORMAT, Ctemp1.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp1.im.get_mpf_t());
	printf("i\n");

	printf("F2 =");
	gmp_printf(GMP_P_FORMAT, Ftemp2.get_mpf_t());
	printf("\n");
*/
	Ctemp3 = Ftemp2 * Ctemp1;
/*
	printf("C3 =");
	gmp_printf(GMP_P_FORMAT, Ctemp3.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp3.im.get_mpf_t());
	printf("i\n");
	printf("\n");

	printf("c1 =");
	printf(P_FORMAT, ctemp1.real());
	printf("+");
	printf(P_FORMAT, ctemp1.imag());
	printf("i\n");

	printf("f2 =");
	printf(P_FORMAT, ftemp2);
	printf("\n");
*/
	ctemp3 = ftemp2 * ctemp1;
/*
	printf("c3 =");
	printf(P_FORMAT, ctemp3.real());
	printf("+");
	printf(P_FORMAT, ctemp3.imag());
	printf("i\n");
	printf("\n");
*/
	diff = abs(Ctemp3 - ctemp3);
/*
	printf("DIFF ");
	gmp_printf(GMP_P_FORMAT, diff.get_mpf_t());
	printf("\n");
*/
	if (abs(diff) > EPSILON) {
	    flag = 1;
	}
    }
    if (flag) {
	printf("Complex * Real test failed\n");
	exit(-1);
    } else {
	printf("Complex * Real test passed\n");
    }
}

void
mpc_div_test1()
{
    printf("Complex / Complex test \n");
    mpc_class Ctemp1;
    mpc_class Ctemp2;
    mpc_class Ctemp3;
    mpf_class Ftemp;
    mpf_class diff;

    complex < double >ctemp1;
    complex < double >ctemp2;
    complex < double >ctemp3;

    int flag = 0;

    for (int i = 0; i < MAX_ITER; i++) {
	Ctemp1 = mpc_randomnumber();
	Ctemp2 = mpc_randomnumber();

	ctemp1.real() = Ctemp1.re.get_d();
	ctemp1.imag() = Ctemp1.im.get_d();
	ctemp2.real() = Ctemp2.re.get_d();
	ctemp2.imag() = Ctemp2.im.get_d();
/*
	printf("C1 =");
	gmp_printf(GMP_P_FORMAT, Ctemp1.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp1.im.get_mpf_t());
	printf("i\n");

	printf("C2 =");
	gmp_printf(GMP_P_FORMAT, Ctemp2.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp2.im.get_mpf_t());
	printf("i\n");
*/
	Ctemp3 = Ctemp1 / Ctemp2;
/*
	printf("C3 =");
	gmp_printf(GMP_P_FORMAT, Ctemp3.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp3.im.get_mpf_t());
	printf("i\n");
	printf("\n");

	printf("c1 =");
	printf(P_FORMAT, ctemp1.real());
	printf("+");
	printf(P_FORMAT, ctemp1.imag());
	printf("i\n");

	printf("c2 =");
	printf(P_FORMAT, ctemp2.real());
	printf("+");
	printf(P_FORMAT, ctemp2.imag());
	printf("i\n");
*/
	ctemp3 = ctemp1 / ctemp2;
/*
	printf("c3 =");
	printf(P_FORMAT, ctemp3.real());
	printf("+");
	printf(P_FORMAT, ctemp3.imag());
	printf("i\n");
	printf("\n");
*/
	diff = abs(Ctemp3 - ctemp3);
/*
	printf("DIFF ");
	gmp_printf(GMP_P_FORMAT, diff.get_mpf_t());
	printf("\n");
*/
	if (abs(diff) > EPSILON) {
	    flag = 1;
	}
    }
    if (flag) {
	printf("Complex / Complex test failed\n");
	exit(-1);
    } else {
	printf("Complex / Complex test passed\n");
    }
}

void
mpc_div_test2()
{
    printf("Complex / Real test \n");
    mpc_class Ctemp1;
    mpf_class Ftemp2;
    mpc_class Ctemp3;
    mpf_class Ftemp;
    mpf_class diff;

    complex < double >ctemp1;
    double ftemp2;
    complex < double >ctemp3;

    int flag = 0;

    for (int i = 0; i < MAX_ITER; i++) {
	Ctemp1 = mpc_randomnumber();
	Ftemp2 = mpf_randomnumber();

	ctemp1.real() = Ctemp1.re.get_d();
	ctemp1.imag() = Ctemp1.im.get_d();
	ftemp2 = Ftemp2.get_d();
/*
	printf("C1 =");
	gmp_printf(GMP_P_FORMAT, Ctemp1.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp1.im.get_mpf_t());
	printf("i\n");

	printf("F2 =");
	gmp_printf(GMP_P_FORMAT, Ftemp2.get_mpf_t());
	printf("\n");
*/

	Ctemp3 = Ctemp1 / Ftemp2;
/*
	printf("C3 =");
	gmp_printf(GMP_P_FORMAT, Ctemp3.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp3.im.get_mpf_t());
	printf("i\n");
	printf("\n");

	printf("c1 =");
	printf(P_FORMAT, ctemp1.real());
	printf("+");
	printf(P_FORMAT, ctemp1.imag());
	printf("i\n");

	printf("f2 =");
	printf(P_FORMAT, ftemp2);
	printf("\n");
*/
	ctemp3 = ctemp1 / ftemp2;
/*
	printf("c3 =");
	printf(P_FORMAT, ctemp3.real());
	printf("+");
	printf(P_FORMAT, ctemp3.imag());
	printf("i\n");
	printf("\n");
*/
	diff = abs(Ctemp3 - ctemp3);
/*
	printf("DIFF ");
	gmp_printf(GMP_P_FORMAT, diff.get_mpf_t());
	printf("\n");
*/
	if (abs(diff) > EPSILON) {
	    flag = 1;
	}
    }
    if (flag) {
	printf("Complex / Real test failed\n");
    } else {
	printf("Complex / Real test passed\n");
    }
}

void
mpc_div_test3()
{
    printf("Real / Complex test \n");
    mpc_class Ctemp1;
    mpf_class Ftemp2;
    mpc_class Ctemp3;
    mpf_class Ftemp;
    mpf_class diff;

    complex < double >ctemp1;
    double ftemp2;
    complex < double >ctemp3;

    int flag = 0;

    for (int i = 0; i < MAX_ITER; i++) {
	Ctemp1 = mpc_randomnumber();
	Ftemp2 = mpf_randomnumber();

	ctemp1.real() = Ctemp1.re.get_d();
	ctemp1.imag() = Ctemp1.im.get_d();
	ftemp2 = Ftemp2.get_d();
/*
	printf("C1 =");
	gmp_printf(GMP_P_FORMAT, Ctemp1.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp1.im.get_mpf_t());
	printf("i\n");

	printf("F2 =");
	gmp_printf(GMP_P_FORMAT, Ftemp2.get_mpf_t());
	printf("\n");
*/
	Ctemp3 = Ftemp2 / Ctemp1;
/*
	printf("C3 =");
	gmp_printf(GMP_P_FORMAT, Ctemp3.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp3.im.get_mpf_t());
	printf("i\n");
	printf("\n");

	printf("c1 =");
	printf(P_FORMAT, ctemp1.real());
	printf("+");
	printf(P_FORMAT, ctemp1.imag());
	printf("i\n");

	printf("f2 =");
	printf(P_FORMAT, ftemp2);
	printf("\n");
*/
	ctemp3 = ftemp2 / ctemp1;
/*
	printf("c3 =");
	printf(P_FORMAT, ctemp3.real());
	printf("+");
	printf(P_FORMAT, ctemp3.imag());
	printf("i\n");
	printf("\n");
*/
	diff = abs(Ctemp3 - ctemp3);
/*
	printf("DIFF ");
	gmp_printf(GMP_P_FORMAT, diff.get_mpf_t());
	printf("\n");
*/
	if (abs(diff) > EPSILON) {
	    flag = 1;
	}
    }
    if (flag) {
	printf("Complex / Real test failed\n");
	exit(-1);
    } else {
	printf("Complex / Real test passed\n");
    }
}


void
mpc_sub_test1()
{
    printf("Complex + Complex test \n");
    mpc_class Ctemp1;
    mpc_class Ctemp2;
    mpc_class Ctemp3;
    mpf_class Ftemp;
    mpf_class diff;

    complex < double >ctemp1;
    complex < double >ctemp2;
    complex < double >ctemp3;

    int flag = 0;

    for (int i = 0; i < MAX_ITER; i++) {
	Ctemp1 = mpc_randomnumber();
	Ctemp2 = mpc_randomnumber();

	ctemp1.real() = Ctemp1.re.get_d();
	ctemp1.imag() = Ctemp1.im.get_d();
	ctemp2.real() = Ctemp2.re.get_d();
	ctemp2.imag() = Ctemp2.im.get_d();
/*
	printf("C1 =");
	gmp_printf(GMP_P_FORMAT, Ctemp1.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp1.im.get_mpf_t());
	printf("i\n");

	printf("C2 =");
	gmp_printf(GMP_P_FORMAT, Ctemp2.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp2.im.get_mpf_t());
	printf("i\n");
*/
	Ctemp3 = Ctemp1 - Ctemp2;
/*
	printf("C3 =");
	gmp_printf(GMP_P_FORMAT, Ctemp3.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp3.im.get_mpf_t());
	printf("i\n");
	printf("\n");

	printf("c1 =");
	printf(P_FORMAT, ctemp1.real());
	printf("+");
	printf(P_FORMAT, ctemp1.imag());
	printf("i\n");

	printf("c2 =");
	printf(P_FORMAT, ctemp2.real());
	printf("+");
	printf(P_FORMAT, ctemp2.imag());
	printf("i\n");
*/
	ctemp3 = ctemp1 - ctemp2;
/*
	printf("c3 =");
	printf(P_FORMAT, ctemp3.real());
	printf("+");
	printf(P_FORMAT, ctemp3.imag());
	printf("i\n");
	printf("\n");
*/
	diff = abs(Ctemp3 - ctemp3);
/*
	printf("DIFF ");
	gmp_printf(GMP_P_FORMAT, diff.get_mpf_t());
	printf("\n");
*/
	if (abs(diff) > EPSILON) {
	    flag = 1;
	}
    }
    if (flag) {
	printf("Complex - Complex SUB test failed\n");
	exit(-1);
    } else {
	printf("Complex - Complex SUB test passed\n");
    }
}

void
mpc_sub_test2()
{
    printf("Complex - Real test \n");
    mpc_class Ctemp1;
    mpf_class Ftemp2;
    mpc_class Ctemp3;

    mpf_class Ftemp;
    mpf_class diff;

    complex < double >ctemp1;
    double ftemp2;
    complex < double >ctemp3;

    int flag = 0;

    for (int i = 0; i < MAX_ITER; i++) {
	Ctemp1 = mpc_randomnumber();
	Ftemp2 = mpf_randomnumber();

	ctemp1.real() = Ctemp1.re.get_d();
	ctemp1.imag() = Ctemp1.im.get_d();
	ftemp2 = Ftemp2.get_d();
/*
	printf("C1 =");
	gmp_printf(GMP_P_FORMAT, Ctemp1.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp1.im.get_mpf_t());
	printf("i\n");

	printf("F2 =");
	gmp_printf(GMP_P_FORMAT, Ftemp2.get_mpf_t());
	printf("\n");
*/
	Ctemp3 = Ctemp1 - Ftemp2;
/*
	printf("C3 =");
	gmp_printf(GMP_P_FORMAT, Ctemp3.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp3.im.get_mpf_t());
	printf("i\n");
	printf("\n");

	printf("c1 =");
	printf(P_FORMAT, ctemp1.real());
	printf("+");
	printf(P_FORMAT, ctemp1.imag());
	printf("i\n");

	printf("f2 =");
	printf(P_FORMAT, ftemp2);
	printf("\n");
*/
	ctemp3 = ctemp1 - ftemp2;
/*
	printf("c3 =");
	printf(P_FORMAT, ctemp3.real());
	printf("+");
	printf(P_FORMAT, ctemp3.imag());
	printf("i\n");
	printf("\n");
*/
	diff = abs(Ctemp3 - ctemp3);
/*
	printf("DIFF ");
	gmp_printf(GMP_P_FORMAT, diff.get_mpf_t());
	printf("\n");
*/
	if (abs(diff) > EPSILON) {
	    flag = 1;
	}
    }
    if (flag) {
	printf("Complex - Real test failed\n");
	exit(-1);
    } else {
	printf("Complex - Real test passed\n");
    }
}


void
mpc_sub_test3()
{
    printf("Real + Complex test \n");
    mpc_class Ctemp1;
    mpf_class Ftemp2;
    mpc_class Ctemp3;

    mpf_class Ftemp;
    mpf_class diff;

    complex < double >ctemp1;
    double ftemp2;
    complex < double >ctemp3;

    int flag = 0;

    for (int i = 0; i < MAX_ITER; i++) {
	Ctemp1 = mpc_randomnumber();
	Ftemp2 = mpf_randomnumber();

	ctemp1.real() = Ctemp1.re.get_d();
	ctemp1.imag() = Ctemp1.im.get_d();
	ftemp2 = Ftemp2.get_d();

/*
	printf("C1 =");
	gmp_printf(GMP_P_FORMAT, Ctemp1.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp1.im.get_mpf_t());
	printf("i\n");

	printf("F2 =");
	gmp_printf(GMP_P_FORMAT, Ftemp2.get_mpf_t());
	printf("\n");
*/

	Ctemp3 = Ftemp2 - Ctemp1;

/*
	printf("C3 =");
	gmp_printf(GMP_P_FORMAT, Ctemp3.re.get_mpf_t());
	printf("+");
	gmp_printf(GMP_P_FORMAT, Ctemp3.im.get_mpf_t());
	printf("i\n");
	printf("\n");

	printf("c1 =");
	printf(P_FORMAT, ctemp1.real());
	printf("+");
	printf(P_FORMAT, ctemp1.imag());
	printf("i\n");

	printf("f2 =");
	printf(P_FORMAT, ftemp2);
	printf("\n");
*/

	ctemp3 = ftemp2 - ctemp1;

/*
	printf("c3 =");
	printf(P_FORMAT, ctemp3.real());
	printf("+");
	printf(P_FORMAT, ctemp3.imag());
	printf("i\n");
	printf("\n");
*/
	diff = abs(Ctemp3 - ctemp3);
/*
	printf("DIFF ");
	gmp_printf(GMP_P_FORMAT, diff.get_mpf_t());
	printf("\n");
*/

	if (abs(diff) > EPSILON) {
	    flag = 1;
	}
    }
    if (flag) {
	printf("Real + Complex test failed\n");
	exit(-1);
    } else {
	printf("Real + Complex test passed\n");
    }
}

int
main(int argc, char *argv[])
{
//initialization
    int default_prec = 200;
    gmp_randstate_t state;

    mpf_set_default_prec(default_prec);
    uniformrandom = new gmp_randclass(gmp_randinit_default);

    mpc_imag_test1();
    mpc_real_test1();
    mpc_subst_test1();
    mpc_abs_test();
    mpc_add_test1();
    mpc_add_test2();
    mpc_add_test3();
    mpc_mul_test1();
    mpc_mul_test2();
    mpc_mul_test3();
    mpc_div_test1();
    mpc_div_test2();
    mpc_div_test3();
    mpc_sub_test1();
    mpc_sub_test2();
    mpc_sub_test3();
    printf("All tests passed succesfully\n");
}
