/*************************************************************************
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 * Copyright 2008 by Nakata, Maho
 *
 * MPACK - multiple precision arithmetic library
 *
 * This file is part of MPACK.
 *
 * MPACK is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * only, as published by the Free Software Foundation.
 *
 * MPACK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3 for more details
 * (a copy is included in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU Lesser General Public License
 * version 3 along with MPACK.  If not, see
 * <http://www.gnu.org/licenses/lgpl.html>
 * for a copy of the LGPLv3 License.
 *
 ************************************************************************/
/*
Copyright (c) 1992-2007 The University of Tennessee.  All rights reserved.

$COPYRIGHT$

Additional copyrights may follow

$HEADER$

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

- Redistributions of source code must retain the above copyright
  notice, this list of conditions and the following disclaimer. 
  
- Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer listed
  in this license in the documentation and/or other materials
  provided with the distribution.
  
- Neither the name of the copyright holders nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.
  
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT  
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT  
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
*/

#include <mblas.h>
#include <mlapack.h>

//ISPEC = 1:  block size
//In these examples, separate code is provided for setting NB for
//real and complex.  We assume that NB will take the same value in
//single or double precision.

int
iMlaenv1(const char *name, const char *opts, int n1, int n2, int n3, int n4)
{

    int nb = 1;

    nb = 64;

    /*
     * if (s_cmp(c2, "GE") == 0) {
     * if (s_cmp(c3, "TRF") == 0) {
     * if (sname) {
     * nb = 64;
     * } else {
     * nb = 64;
     * }
     * } else if (s_cmp(c3, "QRF") == 0 || s_cmp(c3, 
     * "RQF") == 0 || s_cmp(c3, "LQF", (ftnlen)
     * 3, (ftnlen)3) == 0 || s_cmp(c3, "QLF") 
     * == 0) {
     * if (sname) {
     * nb = 32;
     * } else {
     * nb = 32;
     * }
     * } else if (s_cmp(c3, "HRD") == 0) {
     * if (sname) {
     * nb = 32;
     * } else {
     * nb = 32;
     * }
     * } else if (s_cmp(c3, "BRD") == 0) {
     * if (sname) {
     * nb = 32;
     * } else {
     * nb = 32;
     * }
     * } else if (s_cmp(c3, "TRI") == 0) {
     * if (sname) {
     * nb = 64;
     * } else {
     * nb = 64;
     * }
     * }
     * } else if (s_cmp(c2, "PO", (ftnlen)2, (ftnlen)2) == 0) {
     * if (s_cmp(c3, "TRF") == 0) {
     * if (sname) {
     * nb = 64;
     * } else {
     * nb = 64;
     * }
     * }
     * } else if (s_cmp(c2, "SY", (ftnlen)2, (ftnlen)2) == 0) {
     * if (s_cmp(c3, "TRF") == 0) {
     * if (sname) {
     * nb = 64;
     * } else {
     * nb = 64;
     * }
     * } else if (sname && s_cmp(c3, "TRD") == 0) {
     * nb = 32;
     * } else if (sname && s_cmp(c3, "GST") == 0) {
     * nb = 64;
     * }
     * } else if (cname && s_cmp(c2, "HE", (ftnlen)2, (ftnlen)2) == 0) {
     * if (s_cmp(c3, "TRF") == 0) {
     * nb = 64;
     * } else if (s_cmp(c3, "TRD") == 0) {
     * nb = 32;
     * } else if (s_cmp(c3, "GST") == 0) {
     * nb = 64;
     * }
     * } else if (sname && s_cmp(c2, "OR", (ftnlen)2, (ftnlen)2) == 0) {
     * if (*(unsigned char *)c3 == 'G') {
     * if (s_cmp(c4, "QR", (ftnlen)2, (ftnlen)2) == 0 || s_cmp(c4, "RQ", 
     * (ftnlen)2, (ftnlen)2) == 0 || s_cmp(c4, "LQ", (ftnlen)2, (
     * ftnlen)2) == 0 || s_cmp(c4, "QL", (ftnlen)2, (ftnlen)2) ==
     * 0 || s_cmp(c4, "HR", (ftnlen)2, (ftnlen)2) == 0 || s_cmp(
     * c4, "TR", (ftnlen)2, (ftnlen)2) == 0 || s_cmp(c4, "BR", (
     * ftnlen)2, (ftnlen)2) == 0) {
     * nb = 32;
     * }
     * } else if (*(unsigned char *)c3 == 'M') {
     * if (s_cmp(c4, "QR", (ftnlen)2, (ftnlen)2) == 0 || s_cmp(c4, "RQ", 
     * (ftnlen)2, (ftnlen)2) == 0 || s_cmp(c4, "LQ", (ftnlen)2, (
     * ftnlen)2) == 0 || s_cmp(c4, "QL", (ftnlen)2, (ftnlen)2) ==
     * 0 || s_cmp(c4, "HR", (ftnlen)2, (ftnlen)2) == 0 || s_cmp(
     * c4, "TR", (ftnlen)2, (ftnlen)2) == 0 || s_cmp(c4, "BR", (
     * ftnlen)2, (ftnlen)2) == 0) {
     * nb = 32;
     * }
     * }
     * } else if (cname && s_cmp(c2, "UN", (ftnlen)2, (ftnlen)2) == 0) {
     * if (*(unsigned char *)c3 == 'G') {
     * if (s_cmp(c4, "QR", (ftnlen)2, (ftnlen)2) == 0 || s_cmp(c4, "RQ", 
     * (ftnlen)2, (ftnlen)2) == 0 || s_cmp(c4, "LQ", (ftnlen)2, (
     * ftnlen)2) == 0 || s_cmp(c4, "QL", (ftnlen)2, (ftnlen)2) ==
     * 0 || s_cmp(c4, "HR", (ftnlen)2, (ftnlen)2) == 0 || s_cmp(
     * c4, "TR", (ftnlen)2, (ftnlen)2) == 0 || s_cmp(c4, "BR", (
     * ftnlen)2, (ftnlen)2) == 0) {
     * nb = 32;
     * }
     * } else if (*(unsigned char *)c3 == 'M') {
     * if (s_cmp(c4, "QR", (ftnlen)2, (ftnlen)2) == 0 || s_cmp(c4, "RQ", 
     * (ftnlen)2, (ftnlen)2) == 0 || s_cmp(c4, "LQ", (ftnlen)2, (
     * ftnlen)2) == 0 || s_cmp(c4, "QL", (ftnlen)2, (ftnlen)2) ==
     * 0 || s_cmp(c4, "HR", (ftnlen)2, (ftnlen)2) == 0 || s_cmp(
     * c4, "TR", (ftnlen)2, (ftnlen)2) == 0 || s_cmp(c4, "BR", (
     * ftnlen)2, (ftnlen)2) == 0) {
     * nb = 32;
     * }
     * }
     * } else if (s_cmp(c2, "GB", (ftnlen)2, (ftnlen)2) == 0) {
     * if (s_cmp(c3, "TRF") == 0) {
     * if (sname) {
     * if (n4 <= 64) {
     * nb = 1;
     * } else {
     * nb = 32;
     * }
     * } else {
     * if (n4 <= 64) {
     * nb = 1;
     * } else {
     * nb = 32;
     * }
     * }
     * }
     * } else if (s_cmp(c2, "PB", (ftnlen)2, (ftnlen)2) == 0) {
     * if (s_cmp(c3, "TRF") == 0) {
     * if (sname) {
     * if (n2 <= 64) {
     * nb = 1;
     * } else {
     * nb = 32;
     * }
     * } else {
     * if (n2 <= 64) {
     * nb = 1;
     * } else {
     * nb = 32;
     * }
     * }
     * }
     * } else if (s_cmp(c2, "TR", (ftnlen)2, (ftnlen)2) == 0) {
     * if (s_cmp(c3, "TRI") == 0) {
     * if (sname) {
     * nb = 64;
     * } else {
     * nb = 64;
     * }
     * }
     * } else if (s_cmp(c2, "LA", (ftnlen)2, (ftnlen)2) == 0) {
     * if (s_cmp(c3, "UUM") == 0) {
     * if (sname) {
     * nb = 64;
     * } else {
     * nb = 64;
     * }
     * }
     * } else if (sname && s_cmp(c2, "ST", (ftnlen)2, (ftnlen)2) == 0) {
     * if (s_cmp(c3, "EBZ") == 0) {
     * nb = 1;
     * }
     * }
     */
    return nb;
}

int
iMlaenv2(const char *name, const char *opts, int n1, int n2, int n3, int n4)
{
    return 1;
}

int
iMlaenv3(const char *name, const char *opts, int n1, int n2, int n3, int n4)
{
    return 1;
}

int
iMlaenv4(const char *name, const char *opts, int n1, int n2, int n3, int n4)
{
    return 1;
}

int
iMlaenv5(const char *name, const char *opts, int n1, int n2, int n3, int n4)
{
    return 1;
}

int
iMlaenv6(const char *name, const char *opts, int n1, int n2, int n3, int n4)
{
    return 1;
}

int
iMlaenv7(const char *name, const char *opts, int n1, int n2, int n3, int n4)
{
    return 1;
}

int
iMlaenv8(const char *name, const char *opts, int n1, int n2, int n3, int n4)
{
    return 1;
}

int
iMlaenv9(const char *name, const char *opts, int n1, int n2, int n3, int n4)
{
    return 1;
}

int
iMlaenv10(const char *name, const char *opts, int n1, int n2, int n3, int n4)
{
    return 1;
}

int
iMlaenv11(const char *name, const char *opts, int n1, int n2, int n3, int n4)
{
    return 1;
}

int
iMlaenv12(const char *name, const char *opts, int n1, int n2, int n3, int n4)
{
    return 1;
}

int
iMlaenv13(const char *name, const char *opts, int n1, int n2, int n3, int n4)
{
    return 1;
}

int
iMlaenv14(const char *name, const char *opts, int n1, int n2, int n3, int n4)
{
    return 1;
}

int
iMlaenv15(const char *name, const char *opts, int n1, int n2, int n3, int n4)
{
    return 1;
}

int
iMlaenv16(const char *name, const char *opts, int n1, int n2, int n3, int n4)
{
    return 1;
}

int
iMlaenv(int ispec, const char *name, const char *opts, int n1, int n2, int n3,
    int n4)
{
    int iret;

    iret = -1;

    if (!Mlsame(name, "R") && !Mlsame(name, "C"))
	return iret;

    switch (ispec) {
    case 1:
	iret = iMlaenv1(name, opts, n1, n2, n3, n4);
    case 2:
	iret = iMlaenv2(name, opts, n1, n2, n3, n4);
    case 3:
	iret = iMlaenv3(name, opts, n1, n2, n3, n4);
    case 4:
	iret = iMlaenv4(name, opts, n1, n2, n3, n4);
    case 5:
	iret = iMlaenv5(name, opts, n1, n2, n3, n4);
    case 6:
	iret = iMlaenv6(name, opts, n1, n2, n3, n4);
    case 7:
	iret = iMlaenv7(name, opts, n1, n2, n3, n4);
    case 8:
	iret = iMlaenv8(name, opts, n1, n2, n3, n4);
    case 9:
	iret = iMlaenv9(name, opts, n1, n2, n3, n4);
    case 10:
	iret = iMlaenv10(name, opts, n1, n2, n3, n4);
    case 11:
	iret = iMlaenv11(name, opts, n1, n2, n3, n4);
    case 12:
	iret = iMlaenv12(name, opts, n1, n2, n3, n4);
    case 13:
	iret = iMlaenv13(name, opts, n1, n2, n3, n4);
    case 14:
	iret = iMlaenv14(name, opts, n1, n2, n3, n4);
    case 15:
	iret = iMlaenv15(name, opts, n1, n2, n3, n4);
    case 16:
	iret = iMlaenv16(name, opts, n1, n2, n3, n4);
    default:
	iret = -1;
    }
    return iret;
}
